
def parsecontrol(fo):
    """This is an extremely simple and probably rather fragile parser for
    debian control files. It has the advantage of being several times faster
    than debian_bundle.deb822."""
    d = {}
    lastkey = None
    for line in fo:
        line = line.rstrip('\n')
        if not line:
            yield d
            d.clear()
            lastkey = None
        else:
            if line[0] == ' ' or line[0] == '\t':
                d[lastkey] += ('\n' if d[lastkey] else '') + line[1:]
            else:
                idx = line.index(':')
                lastkey = line[:idx]
                d[lastkey] = line[idx+1:].lstrip(' ')
    if d:
        yield d
